/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import org.threeten.bp.LocalDate;

import java.util.Objects;

/**
 * Information related to the purchased item.
 */
@ApiModel(description = "Information related to the purchased item.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class PurchasedItem {
  @SerializedName("label")
  private String label = null;

  @SerializedName("model_number")
  private String modelNumber = null;

  @SerializedName("manufacturer")
  private String manufacturer = null;

  @SerializedName("price")
  private Model91 price = null;

  @SerializedName("is_full_charged_on_card")
  private Boolean isFullChargedOnCard = null;

  @SerializedName("purchase_date")
  private LocalDate purchaseDate = null;

  public PurchasedItem label(String label) {
    this.label = label;
    return this;
  }

   /**
   * Label of the item implied into the claim.
   * @return label
  **/
  @ApiModelProperty(value = "Label of the item implied into the claim.")
  public String getLabel() {
    return label;
  }

  public void setLabel(String label) {
    this.label = label;
  }

  public PurchasedItem modelNumber(String modelNumber) {
    this.modelNumber = modelNumber;
    return this;
  }

   /**
   * Model number of the item.
   * @return modelNumber
  **/
  @ApiModelProperty(value = "Model number of the item.")
  public String getModelNumber() {
    return modelNumber;
  }

  public void setModelNumber(String modelNumber) {
    this.modelNumber = modelNumber;
  }

  public PurchasedItem manufacturer(String manufacturer) {
    this.manufacturer = manufacturer;
    return this;
  }

   /**
   * Name of the manufacturer.
   * @return manufacturer
  **/
  @ApiModelProperty(value = "Name of the manufacturer.")
  public String getManufacturer() {
    return manufacturer;
  }

  public void setManufacturer(String manufacturer) {
    this.manufacturer = manufacturer;
  }

  public PurchasedItem price(Model91 price) {
    this.price = price;
    return this;
  }

   /**
   * Get price
   * @return price
  **/
  @ApiModelProperty(value = "")
  public Model91 getPrice() {
    return price;
  }

  public void setPrice(Model91 price) {
    this.price = price;
  }

  public PurchasedItem isFullChargedOnCard(Boolean isFullChargedOnCard) {
    this.isFullChargedOnCard = isFullChargedOnCard;
    return this;
  }

   /**
   * Does the item has been full paid/charged with the card?
   * @return isFullChargedOnCard
  **/
  @ApiModelProperty(value = "Does the item has been full paid/charged with the card?")
  public Boolean isIsFullChargedOnCard() {
    return isFullChargedOnCard;
  }

  public void setIsFullChargedOnCard(Boolean isFullChargedOnCard) {
    this.isFullChargedOnCard = isFullChargedOnCard;
  }

  public PurchasedItem purchaseDate(LocalDate purchaseDate) {
    this.purchaseDate = purchaseDate;
    return this;
  }

   /**
   * Date when the purchase has been done. ISO 8601 format (YYYY-MM-DD).
   * @return purchaseDate
  **/
  @ApiModelProperty(value = "Date when the purchase has been done. ISO 8601 format (YYYY-MM-DD).")
  public LocalDate getPurchaseDate() {
    return purchaseDate;
  }

  public void setPurchaseDate(LocalDate purchaseDate) {
    this.purchaseDate = purchaseDate;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PurchasedItem purchasedItem = (PurchasedItem) o;
    return Objects.equals(this.label, purchasedItem.label) &&
        Objects.equals(this.modelNumber, purchasedItem.modelNumber) &&
        Objects.equals(this.manufacturer, purchasedItem.manufacturer) &&
        Objects.equals(this.price, purchasedItem.price) &&
        Objects.equals(this.isFullChargedOnCard, purchasedItem.isFullChargedOnCard) &&
        Objects.equals(this.purchaseDate, purchasedItem.purchaseDate);
  }

  @Override
  public int hashCode() {
    return Objects.hash(label, modelNumber, manufacturer, price, isFullChargedOnCard, purchaseDate);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PurchasedItem {\n");
    
    sb.append("    label: ").append(toIndentedString(label)).append("\n");
    sb.append("    modelNumber: ").append(toIndentedString(modelNumber)).append("\n");
    sb.append("    manufacturer: ").append(toIndentedString(manufacturer)).append("\n");
    sb.append("    price: ").append(toIndentedString(price)).append("\n");
    sb.append("    isFullChargedOnCard: ").append(toIndentedString(isFullChargedOnCard)).append("\n");
    sb.append("    purchaseDate: ").append(toIndentedString(purchaseDate)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

